DEF VAR days AS INTEGER.
DEF VAR date1 AS DATE INIT ?.
DEF VAR date2 AS DATE INIT ?.

date1 = (startDate:INPUT-VALUE IN FRAME {1}) NO-ERROR.
date2 = (endDate:INPUT-VALUE IN FRAME {1}) NO-ERROR.

IF date1 = ? THEN DO:
   err = "Specify Check-in Date". 
   RETURN.
END.

IF date2 = ? THEN DO:
   err = "Specify Check-out Date". 
   RETURN.
END.

days = date2 - date1.

IF days < 1 THEN DO:
   err = "Check-out Date should be after Check-in Date". 
   RETURN.
END.

IF days > 999 THEN DO:
   err = "Time period is too large". 
   RETURN.
END.