&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI ADM2
/* Procedure Description
"Version 9 SmartFolder object"
*/
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*------------------------------------------------------------------------
  File:        V9 folder - wrapper for Videosoft OCX
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/
/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */
CREATE WIDGET-POOL.
/* ***************************  Definitions  ************************** */
/* Parameters Definitions ---                                           */
{agbl9df0.i}
  &GLOB ADMClass folder
&GLOBAL-DEFINE PSelectPage SelectPage
/* Local Variable Definitions ---                                       */
    
    DEFINE VARIABLE        number-of-pages    AS INTEGER   NO-UNDO.
    
  &IF "{&xcInstanceProperties}":U NE "":U &THEN
    &GLOB xcInstanceProperties {&xcInstanceProperties},
  &ENDIF
  &GLOB xcInstanceProperties {&xcInstanceProperties}~
FolderLabels,FolderTabType
  &IF "{&xcTranslatableProperties}":U NE "":U &THEN
    &GLOB xcTranslatableProperties {&xcTranslatableProperties},
  &ENDIF
  &GLOB xcTranslatableProperties {&xcTranslatableProperties}~
FolderLabels
&IF DEFINED (ADM-PROPERTY-DLG) = 0 &THEN
  /*&SCOP ADM-PROPERTY-DLG adm2/support/folderd.w*/
  &SCOP adm-property-dlg xadm/adm2/support/cmfolderd.w
&ENDIF
/***********************  DEFINITIONS  *************************/

/* folder vars */
/* No longer used - but keep the variables for the get/set functions */
DEFINE VARIABLE l-foldertabside     AS      INT         NO-UNDO.
DEFINE VARIABLE l-foldertabsperpage AS      INT         NO-UNDO.
DEFINE VARIABLE l-foldermultirow    AS      LOG         NO-UNDO.
DEFINE VARIABLE AlLockRefresh       AS LOG INIT no          NO-UNDO.
/* Defined in afoldml0.i
DEFINE VARIABLE LhContainer        AS HANDLE NO-UNDO.
DEFINE VARIABLE LhTabFrame AS HANDLE EXTENT {&max-tab-rows} NO-UNDO.
DEFINE VARIABLE LhTab AS HANDLE EXTENT {&max-labels}  NO-UNDO.
DEFINE VARIABLE LiNumTabFrames AS INTEGER NO-UNDO.
DEFINE VARIABLE LhTabBottomFrame AS HANDLE NO-UNDO.
*/
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 
/* ********************  Preprocessor Definitions  ******************** */
&Scoped-define PROCEDURE-TYPE SmartFolder
&Scoped-define DB-AWARE no
&Scoped-define ADM-SUPPORTED-LINKS Page-Source
/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME Folder-Frm
/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */
/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME

/* ************************  Function Prototypes ********************** */
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD getAiNumberOfPages C-Win 
FUNCTION getAiNumberOfPages RETURNS INTEGER
  ( /* parameter-definitions */ )  FORWARD.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD getClickActive C-Win 
FUNCTION getClickActive RETURNS CHARACTER
  ( /* parameter-definitions */ )  FORWARD.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD getFolderLabels C-Win 
FUNCTION getFolderLabels RETURNS CHARACTER
  (   )  FORWARD.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD GetFolderMultiRow C-Win 
FUNCTION GetFolderMultiRow RETURNS CHARACTER
  ( /* parameter-definitions */ )  FORWARD.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD GetFolderTabSide C-Win 
FUNCTION GetFolderTabSide RETURNS CHARACTER
  ( /* parameter-definitions */ )  FORWARD.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD GetFolderTabsPerPage C-Win 
FUNCTION GetFolderTabsPerPage RETURNS CHARACTER
  ( /* parameter-definitions */ )  FORWARD.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD getFolderTabType C-Win 
FUNCTION getFolderTabType RETURNS INTEGER
  ( )  FORWARD.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD getPageTarget C-Win 
FUNCTION getPageTarget RETURNS CHARACTER
  (  )  FORWARD.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD getPageTargetEvents C-Win 
FUNCTION getPageTargetEvents RETURNS CHARACTER
  (  )  FORWARD.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD setAlLockRefresh C-Win 
FUNCTION setAlLockRefresh RETURNS CHARACTER
  ( INPUT Il AS LOG )  FORWARD.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD setFolderLabels C-Win 
FUNCTION setFolderLabels RETURNS LOGICAL
  ( pcLabels AS CHARACTER )  FORWARD.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD SetFolderMultiRow C-Win 
FUNCTION SetFolderMultiRow RETURNS CHARACTER
  ( INPUT i AS CHAR )  FORWARD.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD SetFolderTabSide C-Win 
FUNCTION SetFolderTabSide RETURNS CHARACTER
  ( INPUT i AS CHAR )  FORWARD.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD SetFolderTabsPerPage C-Win 
FUNCTION SetFolderTabsPerPage RETURNS CHARACTER
  ( INPUT i AS CHAR )  FORWARD.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD setFolderTabType C-Win 
FUNCTION setFolderTabType RETURNS LOGICAL
  ( piTabType AS INTEGER )  FORWARD.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD setPageTarget C-Win 
FUNCTION setPageTarget RETURNS LOGICAL
  ( pcTarget AS CHARACTER )  FORWARD.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

/* ***********************  Control Definitions  ********************** */

/* ************************  Frame Definitions  *********************** */
DEFINE FRAME Folder-Frm
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 46.43 BY 4.15.

/* *********************** Procedure Settings ************************ */
&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartFolder
   Allow: Basic
   Frames: 1
   Add Fields to: NEITHER
   Other Settings: PERSISTENT-ONLY
 */
/* This procedure should always be RUN PERSISTENT.  Report the error,  */
/* then cleanup and return.                                            */
IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:
  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT.":U
          VIEW-AS ALERT-BOX ERROR BUTTONS OK.
  RETURN.
END.
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS
/* *************************  Create Window  ************************** */
&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW C-Win ASSIGN
         HEIGHT             = 4.15
         WIDTH              = 47.57.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB C-Win 
/* ************************* Included-Libraries *********************** */
{afoldml0.i}
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ***********  Runtime Attributes and AppBuilder Settings  *********** */
&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME Folder-Frm
   NOT-VISIBLE FRAME-NAME Size-to-Fit                                   */
ASSIGN 
       FRAME Folder-Frm:SCROLLABLE       = FALSE
       FRAME Folder-Frm:HIDDEN           = TRUE
       FRAME Folder-Frm:SELECTABLE       = TRUE
       FRAME Folder-Frm:MOVABLE          = TRUE
       FRAME Folder-Frm:RESIZABLE        = TRUE
       FRAME Folder-Frm:PRIVATE-DATA     = 
                "TAB-FOLDER".
/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

/* Setting information for Queries and Browse Widgets fields            */
&ANALYZE-SUSPEND _QUERY-BLOCK FRAME Folder-Frm
/* Query rebuild information for FRAME Folder-Frm
     _Query            is NOT OPENED
*/  /* FRAME Folder-Frm */
&ANALYZE-RESUME
 

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 

/* ***************************  Main Block  *************************** */

  /* Folder-specific properties which are in the property temp-table. */
  &GLOB xpFolderLabels       
  &GLOB xpFolderTabType      
  &GLOB xpPageTarget         
  &GLOB xpPageTargetEvents   
  /* Now include the other props files which will start the ADMProps def. */
  {src/adm2/visprop.i}
  /* and then we add our folder property defs to that... */
  ghADMProps:ADD-NEW-FIELD('FolderLabels':U, 'CHAR':U, 0, ?, '':U).
  ghADMProps:ADD-NEW-FIELD('FolderTabType':U, 'INT':U, 0, ?, 1).
  ghADMProps:ADD-NEW-FIELD('PageTarget':U, 'CHAR':U, 0, ?, '':U).
  ghADMProps:ADD-NEW-FIELD('PageTargetEvents':U, 'CHAR':U, 0, ?, 'changeFolderPage,deleteFolderPage,PEVENTMoveToBottom':U).    
  /* Now include out parent class file for visual objects. */
  {src/adm2/visual.i}

&IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN
   RUN initializeObject.
&ENDIF
/* Layout super procedure added at top of stack */
{alayoml0.i}
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

/* **********************  Internal Procedures  *********************** */
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects C-Win  _ADM-CREATE-OBJECTS
PROCEDURE adm-create-objects :
/*------------------------------------------------------------------------------
  Purpose:     Create handles for all SmartObjects used in this procedure.
               After SmartObjects are initialized, then SmartLinks are added.
  Parameters:  <none>
------------------------------------------------------------------------------*/
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE changeFolderPage C-Win 
PROCEDURE changeFolderPage :
/* -----------------------------------------------------------
      Purpose:    Changes the folder visualization when a new page is
                  selected (from the folder or elsewhere). 
      Parameters:  <none>
      Notes: 
    -------------------------------------------------------------*/   
    DEFINE VARIABLE sts     AS LOGICAL NO-UNDO.
    DEFINE VARIABLE page#   AS INTEGER NO-UNDO.
  
    IF VALID-HANDLE (LhContainer) THEN 
      {get CurrentPage page# LhContainer}.
    ELSE ASSIGN page# = 1.    /* For design mode. */
    IF page# > 0                AND
       page# <= {&max-labels}   AND
       VALID-HANDLE(LhTab[page#])
    THEN RUN PUpdateTabVisualisation(page#).
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE create-folder-label C-Win 
PROCEDURE create-folder-label :
/* -----------------------------------------------------------
      Purpose:     Defines an image for a single tab and sets its label.
      Parameters:  INPUT page number, label
      Notes:       Doesn't do anything, don't think is used in ADM2.
    -------------------------------------------------------------*/   
     
    DEFINE INPUT PARAMETER p-page#        AS INTEGER   NO-UNDO.
    DEFINE INPUT PARAMETER p-page-label   AS CHARACTER NO-UNDO.

END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE create-folder-page C-Win 
PROCEDURE create-folder-page :
/* -----------------------------------------------------------
      Purpose:     Create a new tab label after initialization.
      Parameters:  INPUT new page number, new tab label
      Notes:       Doesn't do anything, don't think is used in ADM2
    -------------------------------------------------------------*/   
    DEFINE INPUT PARAMETER p-page#      AS INTEGER   NO-UNDO.
    DEFINE INPUT PARAMETER p-new-label  AS CHARACTER NO-UNDO.
    /*
    DEFINE VARIABLE i             AS INTEGER NO-UNDO.
    DEFINE VARIABLE num-labels    AS INTEGER NO-UNDO. 
    DEFINE VARIABLE labels        AS CHARACTER NO-UNDO.
    DEFINE VARIABLE new-labels    AS CHARACTER NO-UNDO INIT "".
   
    {get FolderLabels labels}.   
    IF labels = ? THEN labels = "". 
    
    num-labels = NUM-ENTRIES(labels,'|':U).
    /* If the new label is on a page that already exists, replace it. */
    IF p-page# <= num-labels THEN
    DO i = 1 TO num-labels:
        new-labels = new-labels + 
            IF i = p-page# THEN p-new-label
            ELSE ENTRY(i, labels, '|':U).
        IF i < num-labels THEN new-labels = new-labels + '|':U.
    END.
    ELSE DO:
        /* If this is higher than the current labels, insert the
           right number of elimiters to make room for it. */
        new-labels = labels.
        DO i = 1 TO p-page# - num-labels - IF num-labels = 0 THEN 1 ELSE 0:
            new-labels = new-labels + '|':U. 
        END.
        new-labels = new-labels + p-new-label.   
    END.                      
    
    {set FolderLabels new-labels}.
    IF NOT AlLockRefresh THEN
        RUN initializeFolder.
    RETURN.
      */
    
  END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE deleteFolderPage C-Win 
PROCEDURE deleteFolderPage :
/* -----------------------------------------------------------
      Purpose:     Remove the tab for a page
      Parameters:  INPUT page number to delete
      Notes:       
    -------------------------------------------------------------*/   
    DEFINE INPUT PARAMETER p-page#  AS INTEGER NO-UNDO.
    DEFINE VARIABLE i       AS INTEGER NO-UNDO.
    DEFINE VARIABLE pos1    AS INTEGER NO-UNDO INIT 0.
    DEFINE VARIABLE pos2    AS INTEGER NO-UNDO. 
    DEFINE VARIABLE labels  AS CHARACTER NO-UNDO.
   
    {get FolderLabels labels}.
    /* Remove the label from the FOLDER-LABELS attribute list */
    DO i = 1 TO p-page# - 1:                                      
        pos1 = INDEX(labels,'|':U, pos1 + 1).
    END.
    pos2 = INDEX(labels,'|':U, pos1 + 1).
    labels = IF pos2 ne 0 THEN SUBSTR(labels, 1, pos1, "CHARACTER":U) +
                                  SUBSTR(labels, pos2, -1, "CHARACTER":U)       
                          ELSE SUBSTR(labels, 1, pos1 - 1, "CHARACTER":U).
    
    {set FolderLabels labels}.
    RETURN. 
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disableFolderPage C-Win 
PROCEDURE disableFolderPage :
/* -----------------------------------------------------------
      Purpose:     Disable and gray out the tab for a page
      Parameters:  INPUT page number to disable
      Notes:       
    -------------------------------------------------------------*/   
    DEFINE INPUT PARAMETER p-page#  AS INTEGER NO-UNDO.
    RUN PSetTabSensitivity IN THIS-PROCEDURE (p-page#,FALSE).
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME Folder-Frm.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enableFolderPage C-Win 
PROCEDURE enableFolderPage :
/* -----------------------------------------------------------
      Purpose:     Enable the tab for a page
      Parameters:  INPUT page number to enable
      Notes:       
    -------------------------------------------------------------*/   
    DEFINE INPUT PARAMETER p-page#  AS INTEGER NO-UNDO.
    RUN PSetTabSensitivity IN THIS-PROCEDURE (p-page#,TRUE).
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeFolder C-Win 
PROCEDURE initializeFolder :
/* -----------------------------------------------------------
      Purpose:     Creates the dynamic images for a tab or notebook
                   folder.
      Parameters:  <none>
      Notes:       Run automatically as part of folder startup.
    -------------------------------------------------------------*/   
    DEFINE VARIABLE folder-labels      AS CHARACTER NO-UNDO.  
        
    {get FolderLabels folder-labels}.
    
    /*
    {get FolderTabType tab-type}.
    number-of-pages =   NUM-ENTRIES(folder-labels,'|':U).
    
    /* RUN resizeObject (FRAME {&FRAME-NAME}:HEIGHT, FRAME {&FRAME-NAME}:WIDTH). */
    /* set side of folder on which tabs go, tabs per page and multi-row flag */
    DEFINE VARIABLE iTabPosition AS INT NO-UNDO.
    CASE    l-foldertabside:
            WHEN    1   THEN    ASSIGN  iTabPosition = 0.    /* top */
            WHEN    2   THEN    ASSIGN  iTabPosition = 3.    /* right */
            WHEN    3   THEN    ASSIGN  iTabPosition = 2.    /* bottom */
            WHEN    4   THEN    ASSIGN  iTabPosition = 1.    /* left */
    END     CASE.
    */
    
    RUN PCreateTabs(folder-labels).
    RUN PAdjustBackgroundFrame.
    
    RUN changeFolderPage. /* Select the current tab */
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeObject C-Win 
PROCEDURE initializeObject :
/* -----------------------------------------------------------
      Purpose:     Local version of the initialize method which starts up
                   the folder object. This runs initializeFolder with
                   the folder attributes.
      Parameters:  <none>
      Notes:       The folder initialization is suppressed in character mode.
    -------------------------------------------------------------*/   
  
  RUN SUPER.
  /* Get the folder's CONTAINER for triggers.
       Note that in design mode the CONTAINER may not be specified;
       the code takes this into account. Also the broker will not
       be available in design mode. */
  LhContainer = WIDGET-HANDLE(DYNAMIC-FUNCTION('linkHandles':U, 'Container-Source':U)) NO-ERROR.
  RUN initializeFolder.
  DEF VAR cInstanceProperties AS CHAR NO-UNDO.
  {get InstanceProperties cInstanceProperties}.
  cInstanceProperties = cInstanceProperties + ",FolderTabSide,FolderTabsPerPage,FolderMultiRow".
  {set InstanceProperties cInstanceProperties}.
  RETURN.
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PEVENTMoveToBottom C-Win 
PROCEDURE PEVENTMoveToBottom :
/*------------------------------------------------------------------------------
  Purpose:     Move frame to bottom to sort out Z Order problem with the
               tab folder object, which seems to put itself on top of the
               Z order when the parent frame is hidden then viewed again.
               
               Run from container (actually from container super procedure).
------------------------------------------------------------------------------*/
    FRAME {&FRAME-NAME}:MOVE-TO-BOTTOM().
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE resizeObject C-Win 
PROCEDURE resizeObject :
/*------------------------------------------------------------------------------
  Purpose:     Sets the size of the rectangles which make up the folder
               "image" whenever it is resized.
  Parameters:  INPUT height and width.
  Notes:       Run automatically when the folder is initialized or resized.
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER p-height AS DECIMAL NO-UNDO.
  DEFINE INPUT PARAMETER p-width  AS DECIMAL NO-UNDO.
  ASSIGN
      FRAME {&FRAME-NAME}:SCROLLABLE = yes
      FRAME {&FRAME-NAME}:VIRTUAL-HEIGHT-PIXELS = 1500
      FRAME {&FRAME-NAME}:VIRTUAL-WIDTH-PIXELS  = 1500
      FRAME {&FRAME-NAME}:HEIGHT = p-height
      FRAME {&FRAME-NAME}:WIDTH  = p-width
      .
      
      IF {fn getObjectInitialized}
      THEN RUN initializeFolder.
      /* ELSE RUN PAdjustBackgroundFrame. Called from initializeFolder */
      
  ASSIGN
      FRAME {&FRAME-NAME}:VIRTUAL-HEIGHT-PIXELS = FRAME {&FRAME-NAME}:HEIGHT-PIXELS
      FRAME {&FRAME-NAME}:VIRTUAL-WIDTH-PIXELS  = FRAME {&FRAME-NAME}:WIDTH-PIXELS
      FRAME {&FRAME-NAME}:SCROLLABLE = no
      .

  
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE showCurrentPage C-Win 
PROCEDURE showCurrentPage :
/*------------------------------------------------------------------------------
  Purpose:     Shows the tab for "current" folder page
  Parameters:  page# - (INTEGER) The current page.
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER page# AS INTEGER NO-UNDO.
  DEFINE VARIABLE sts     AS LOGICAL NO-UNDO.
  IF VALID-HANDLE(LhTab[page#])
  THEN APPLY "MOUSE-SELECT-DOWN" TO LhTab[page#].
  
END PROCEDURE.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
/* ************************  Function Implementations ***************** */
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION getAiNumberOfPages C-Win 
FUNCTION getAiNumberOfPages RETURNS INTEGER
  ( /* parameter-definitions */ ) :
/*------------------------------------------------------------------------------
  Purpose:  This attribute is the number of pages in the folder
    Notes:  
------------------------------------------------------------------------------*/
  RETURN number-of-pages.   /* Function return value. */
END FUNCTION.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION getClickActive C-Win 
FUNCTION getClickActive RETURNS CHARACTER
  ( /* parameter-definitions */ ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
  RETURN STRING(LlClickActive,"yes/no").
  
END FUNCTION.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION getFolderLabels C-Win 
FUNCTION getFolderLabels RETURNS CHARACTER
  (   ) :
/*------------------------------------------------------------------------------
  Purpose:  Returns the folder labels property.
    Notes:  
------------------------------------------------------------------------------*/
  DEFINE VARIABLE cLabels AS CHARACTER NO-UNDO.
  {get FolderLabels cLabels}.
  RETURN cLabels.
END FUNCTION.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION GetFolderMultiRow C-Win 
FUNCTION GetFolderMultiRow RETURNS CHARACTER
  ( /* parameter-definitions */ ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
/*     RUN initPages("1"). */
  RETURN STRING(l-FolderMultiRow,"Yes/No").
END FUNCTION.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION GetFolderTabSide C-Win 
FUNCTION GetFolderTabSide RETURNS CHARACTER
  ( /* parameter-definitions */ ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
  RETURN STRING(l-foldertabside).
  
END FUNCTION.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION GetFolderTabsPerPage C-Win 
FUNCTION GetFolderTabsPerPage RETURNS CHARACTER
  ( /* parameter-definitions */ ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
  RETURN STRING(l-FolderTabsPerPage).
END FUNCTION.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION getFolderTabType C-Win 
FUNCTION getFolderTabType RETURNS INTEGER
  ( ) :
/*------------------------------------------------------------------------------
  Purpose:  Returns the folder tab type, 1 or 2
    Notes:  
------------------------------------------------------------------------------*/
  DEFINE VARIABLE iType AS INTEGER NO-UNDO.
  {get FolderTabType iType}.
  RETURN iType.
END FUNCTION.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION getPageTarget C-Win 
FUNCTION getPageTarget RETURNS CHARACTER
  (  ) :
/*------------------------------------------------------------------------------
  Purpose:  Returns the handle of the folder's "PageTarget", normally its container.
    Notes:  
------------------------------------------------------------------------------*/
  DEFINE VARIABLE cTarget AS CHARACTER NO-UNDO.
  {get PageTarget cTarget}.
  RETURN cTarget.
END FUNCTION.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION getPageTargetEvents C-Win 
FUNCTION getPageTargetEvents RETURNS CHARACTER
  (  ) :
/*------------------------------------------------------------------------------
  Purpose:  Returns a list of the events the folder expects to receive from
            its PageTarget (normally its container).
    Notes:  
------------------------------------------------------------------------------*/
  DEFINE VARIABLE cEvents AS CHARACTER NO-UNDO.
  {get PageTargetEvents cEvents}.
  RETURN cEvents.
END FUNCTION.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION setAlLockRefresh C-Win 
FUNCTION setAlLockRefresh RETURNS CHARACTER
  ( INPUT Il AS LOG ) :
/*------------------------------------------------------------------------------
  Purpose:  Lock refreshing of folder while we add labels
    Notes:  
------------------------------------------------------------------------------*/
  AlLockRefresh = Il.
  /* If unlocking then refresh the folder display as we've probably added tabs */
  IF Il = no THEN
    RUN initializeFolder.
  RETURN "".   /* Function return value. */
END FUNCTION.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION setFolderLabels C-Win 
FUNCTION setFolderLabels RETURNS LOGICAL
  ( pcLabels AS CHARACTER ) :
/*------------------------------------------------------------------------------
  Purpose:  Sets folder labels.
    Notes:  Basic folder property.
------------------------------------------------------------------------------*/
  /* Ensure [Case] is replaced in the folder labels string. This is so
     we can parameterise the word used for Case=Call=Task=Issue etc
  */
  pcLabels = REPLACE(pcLabels,"[Case]",GcCase).
  {set FolderLabels pcLabels}.
  RETURN TRUE.
END FUNCTION.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION SetFolderMultiRow C-Win 
FUNCTION SetFolderMultiRow RETURNS CHARACTER
  ( INPUT i AS CHAR ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
  l-foldermultirow = (i = "YES" OR i = "TRUE").
  RETURN "".   /* Function return value. */
END FUNCTION.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION SetFolderTabSide C-Win 
FUNCTION SetFolderTabSide RETURNS CHARACTER
  ( INPUT i AS CHAR ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
  l-foldertabside = INT(i).
  RETURN "".   /* Function return value. */
END FUNCTION.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION SetFolderTabsPerPage C-Win 
FUNCTION SetFolderTabsPerPage RETURNS CHARACTER
  ( INPUT i AS CHAR ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
  l-foldertabsperpage = INT(i).
  RETURN "".   /* Function return value. */
END FUNCTION.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION setFolderTabType C-Win 
FUNCTION setFolderTabType RETURNS LOGICAL
  ( piTabType AS INTEGER ) :
/*------------------------------------------------------------------------------
  Purpose:  Sets the folder tab type to 1 or 2
    Notes:  
------------------------------------------------------------------------------*/
  IF piTabType NE 1 AND piTabType NE 2 THEN
    RETURN FALSE.   
  ELSE DO:
     {set FolderTabType piTabType}.
     RETURN TRUE.
  END.
END FUNCTION.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION setPageTarget C-Win 
FUNCTION setPageTarget RETURNS LOGICAL
  ( pcTarget AS CHARACTER ) :
/*------------------------------------------------------------------------------
  Purpose:  Sets the PageTarget object handle, normally the folder's container.
    Notes:  
------------------------------------------------------------------------------*/
  {set PageTarget pcTarget}.
  RETURN TRUE.
END FUNCTION.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
