#!/bin/bash

# defaults
build_path="../build/lib"
p2j_path="../../p2j/build/lib"

# use P2J_HOME environment variable if set
if [ -n "${P2J_HOME}" ] ; then
   p2j_path="${P2J_HOME}"
fi

cpath="${build_path}/embedded.jar:${p2j_path}/p2j.jar:${build_path}/jetty-all-9.1.0-SNAPSHOT.jar:${build_path}/javax.servlet-api-3.1.0.jar:${build_path}/slf4j-jdk14-1.6.1.jar:.:"

java -classpath "${cpath}" com.goldencode.testcases.embedded.EmbeddedWebAppDriver "$@"
