@echo off

if not exist %~dp0hotel.pf (

	echo hotel.bat
	echo Copy or rename hotel.pf.template to hotel.pf
	echo Edit hotel.pf and amend the following values:
	echo   -H ^<Server^>
	echo   -S ^<Port^>
	pause
	exit /b -1
)

::ensure we'e running in 32 bit mode (to get the correct registry settings for Progress)
IF "%PROCESSOR_ARCHITECTURE%"=="AMD64" (
	%windir%\SysWoW64\cmd.exe /C %0 %*
	exit /b %ERRORLEVEL%
)


setlocal enableExtensions

:: Get location of Progress from Registry
set KEY_NAME="HKEY_LOCAL_MACHINE\SOFTWARE\PSC\PROGRESS\10.2B\Startup"
set VALUE_NAME=DLC

FOR /F "usebackq skip=2 tokens=1-3" %%A IN (`REG QUERY %KEY_NAME% /v %VALUE_NAME% 2^>nul`) DO (
    set ValueName=%%A
    set ValueType=%%B
    set ValueValue=%%C
)

if not defined ValueValue (
	echo Progress 10.2B installation cannot be found in registry
	exit /b -1
)

set DLC=%ValueValue%


call %DLC%\bin\proDebugEnable -enable-all

start /D %~dp0 %DLC%\bin\prowin32.exe -ininame hotel.ini -pf hotel.pf